package mapReduce;

import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.FileInputFormat;
import org.apache.hadoop.mapred.FileOutputFormat;
import org.apache.hadoop.mapred.JobClient;
import org.apache.hadoop.mapred.JobConf;

public class ArticleParserDriver {

	private static String inputDirectory = "NewYorkTimesArticles";
	private static String outputDirectory = "ArticlesParsedData";
	
	public static void main(String[] args) {
		JobClient client = new JobClient();
		JobConf conf = new JobConf(mapReduce.ArticleParserDriver.class);

		conf.setMapperClass(mapReduce.ArticleParserMapper.class);
		conf.setReducerClass(mapReduce.ArticleParserReducer.class);
		
		conf.setOutputKeyClass(Text.class);
		conf.setOutputValueClass(Text.class);
		
		conf.setNumReduceTasks(10);

		FileInputFormat.setInputPaths(conf, new Path(inputDirectory));
		FileOutputFormat.setOutputPath(conf, new Path(outputDirectory));
		
		NewYorkTimesNewsDriver.deleteExistingDirectory(outputDirectory);

		client.setConf(conf);
		try {
			JobClient.runJob(conf);
		} catch (Exception e) {
			e.printStackTrace();
		} 
	}

}
