package mapReduce;

import java.io.IOException;
import java.util.Iterator;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.MapReduceBase;
import org.apache.hadoop.mapred.OutputCollector;
import org.apache.hadoop.mapred.Reducer;
import org.apache.hadoop.mapred.Reporter;

public class KeywordSearchReducer extends MapReduceBase implements
		Reducer<Text, Text, Text, Text> {

	private Text keywordSearchOutput = new Text();
	public static String numberKeywordsSeparator = "Total number of Keywords: ";
	
	@Override
	public void reduce(Text key, Iterator<Text> values,
			OutputCollector<Text, Text> output, Reporter reporter) throws IOException {

		StringBuilder keywordsStringBuilder = new StringBuilder(496);
        int keywordCount = 0;
        
        keywordsStringBuilder.append("Keywords in article: ");
        
        while (values.hasNext()) {
        	
        	String keyword = values.next().toString();
        	if(keywordsStringBuilder.indexOf(keyword) == -1) {
        		keywordsStringBuilder.append(keyword);
        		keywordsStringBuilder.append("; ");
        	}
        	keywordCount ++;
        }
        
        keywordsStringBuilder.append(numberKeywordsSeparator);
        keywordsStringBuilder.append(keywordCount);
        
        keywordSearchOutput.set(keywordsStringBuilder.toString());
        output.collect(key, keywordSearchOutput);
	}
}
