package mapReduce;

import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.FileInputFormat;
import org.apache.hadoop.mapred.FileOutputFormat;
import org.apache.hadoop.mapred.JobClient;
import org.apache.hadoop.mapred.JobConf;

public class SortArticleTitlesDriver {

	private static String inputDirectory = "ArticlesOutput";
	private static String outputDirectory = "FilteredArticles";
	
	public static void main(String[] args) {
		
		JobClient client = new JobClient();
		JobConf conf = new JobConf(mapReduce.SortArticleTitlesDriver.class);

		conf.setMapperClass(SortArticleTitlesMapper.class);
		conf.setReducerClass(SortArticleTitlesReducer.class);

		conf.setOutputKeyClass(Text.class);
		conf.setOutputValueClass(Text.class);

		FileInputFormat.setInputPaths(conf, new Path(inputDirectory));
		FileOutputFormat.setOutputPath(conf, new Path(outputDirectory));
		
		NewYorkTimesNewsDriver.deleteExistingDirectory(outputDirectory);

		client.setConf(conf);
		try {
			JobClient.runJob(conf);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
