package mapReduce;

import java.io.IOException;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.MapReduceBase;
import org.apache.hadoop.mapred.Mapper;
import org.apache.hadoop.mapred.OutputCollector;
import org.apache.hadoop.mapred.Reporter;

public class SortArticleTitlesMapper extends MapReduceBase implements Mapper<LongWritable, Text, Text, Text> {

	private Text outputKey = new Text();          
	private Text outputValue = new Text();  
	
	@Override
	public void map(LongWritable key, Text value, OutputCollector<Text, Text> output, Reporter reporter) throws IOException {

        String line = value.toString();                  
        int splitterIndex = value.toString().indexOf(KeywordSearchReducer.numberKeywordsSeparator);
        String numberOfKeywords = line.substring(splitterIndex + 26, line.length());
        
        String articleInformation = line.substring(0, splitterIndex);
        	
        outputKey.set(numberOfKeywords);                          
        outputValue.set(articleInformation);
        
        output.collect(outputKey, outputValue);                  		
	}
}
